# -*- coding: utf-8 -*-
"""
Created on Fri Apr 21 09:53:29 2017

@author: ldubard
r+te+tm+ts=1
r=1-dt/tmax

X(n+1)=(L+I)X(n)
X(n)=(L+I)^n*X(0)
"""
#import tkinter as tk
#from tkinter.filedialog import askopenfilename
#from tkinter import messagebox
from time import time
import matplotlib.pyplot as plt
import numpy as np
from GUI import *

##################################################variables initiales#######################################"
p=100#nb de classes d'âges
annee=2007
reste=[0 for x in range(p)]
pop="populationfrance1998_2016.csv"
mort="mortalitefrance1998_2015.csv"
fec="feconditefrance1998_2015.csv"
em="emigrationfrance1998_2015.csv"
im="immigrationfrance1998_2015.csv"

####################################prise en charge des fichiers de statistiques################################

def ouverturefichier(pop,mort,fec,em,im,annee):
    with open(pop,"r") as fichier:
        liste=fichier.readlines()
        fichierpopulationinitiale=[(liste[x].split(";")) for x in range(len(liste))][10:10+100+3]
        colonne=fichierpopulationinitiale[0].index(str(annee))
        fichierfemme=[(liste[x].split(";")) for x in range(len(liste))][232:335]
        fichierhomme=[(liste[x].split(";")) for x in range(len(liste))][121:224]
        initiale=[0 for x in range(p)]
        femmes=[0 for x in range(p)]
        hommes=[0 for x in range(p)]
        for i in range(p-1):
            try:
                initiale[i]=float(fichierpopulationinitiale[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
            except:
                initiale[i]=0
            try:
                femmes[i]=float(fichierfemme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
            except:
                femmes[i]=0
            try:
                hommes[i]=float(fichierhomme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
            except:
                hommes[i]=0
        for i in range(p-1,len(fichierpopulationinitiale)-2):
            try:
                initiale[p-1]+=float(fichierpopulationinitiale[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
                femmes[p-1]+=float(fichierfemme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
                hommes[p-1]+=float(fichierhomme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
            except:
                continue
    with open(mort,"r") as fichier:
        liste=fichier.readlines()
        fichiermortalitehomme=[liste[x].split(";") for x in range(len(liste))][105:192]
        fichiermortalitefemme=[liste[x].split(";") for x in range(len(liste))][200:287]
        fichiermortalite=[liste[x].split(";") for x in range(len(liste))][10:97]#debut du tableau à la 11eme ligne du fichier csv et fin à la 97eme
        colonne=fichiermortalite[0].index(str(annee))
        mortalite=[0 for x in range(p)]
        mortalitehomme=[0 for x in range(p)]
        mortalitefemme=[0 for x in range(p)]
        for i in range(len(fichiermortalite)-1):
            mortalitefemme[i]=float(fichiermortalitefemme[i+1][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
            mortalitehomme[i]=float(fichiermortalitehomme[i+1][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
            mortalite[i]=float(fichiermortalite[i+1][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
        for i in range(len(fichiermortalite)-1,p-1):
            mortalite[i]=float(fichiermortalite[len(fichiermortalite)-1][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
            mortalitehomme[i]=float(fichiermortalitehomme[len(fichiermortalite)-1][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
            mortalitefemme[i]=float(fichiermortalitefemme[len(fichiermortalite)-1][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))
        #

    with open(fec,"r") as fichier:
        liste=fichier.readlines()
        fichierfecondite=[liste[x].split(";") for x in range(len(liste))][10:48]
        colonne=fichierfecondite[0].index(str(annee))
        fecondite=[0 for x in range(p)]
        for i in range(len(fichierfecondite)-2):
            fecondite[i+15]=float(fichierfecondite[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))*femmes[i+15]/initiale[i+15]
        for i in range(len(fichierfecondite)-2,p-15):
            fecondite[i+15]=float(fichierfecondite[len(fichierfecondite)-1][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))*femmes[i+15]/initiale[i+15]


    with open(em,"r") as fichier:
        liste=fichier.readlines()
        fichieremigration=[liste[x].split(";") for x in range(len(liste))][11:114]
        fichieremigrationhomme=[liste[x].split(";") for x in range(len(liste))][123:226]
        fichieremigrationfemme=[liste[x].split(";") for x in range(len(liste))][235:338]
        colonne=fichieremigration[0].index(str(annee))
        emmigration=[0 for x in range(p)]
        emmigrationhomme=[0 for x in range(p)]
        emmigrationfemme=[0 for x in range(p)]
        for i in range(p-1):
            emmigration[i]=float(fichieremigration[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ","").replace(":","0"))/initiale[i] if initiale[i]!=0 else 0
            emmigrationhomme[i]=float(fichieremigrationhomme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ","").replace(":","0"))/hommes[i] if hommes[i]!=0 else 0
            emmigrationfemme[i]=float(fichieremigrationfemme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ","").replace(":","0"))/femmes[i] if femmes[i]!=0 else 0
        for i in range(p-1,len(fichieremigration)-2):
            emmigration[p-1]+=float(fichieremigration[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ","").replace(":","0"))/initiale[p-1] if initiale[p-1]!=0 else 0
            emmigrationhomme[p-1]+=float(fichieremigrationhomme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ","").replace(":","0"))/hommes[p-1] if hommes[p-1]!=0 else 0
            emmigrationfemme[p-1]+=float(fichieremigrationfemme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ","").replace(":","0"))/femmes[p-1] if femmes[p-1]!=0 else 0
    with open(im,"r") as fichier:
        liste=fichier.readlines()
        fichierimmigration=[liste[x].split(";") for x in range(len(liste))][11:114]
        fichierimmigrationhomme=[liste[x].split(";") for x in range(len(liste))][123:226]
        fichierimmigrationfemme=[liste[x].split(";") for x in range(len(liste))][235:338]
        colonne=fichierimmigration[0].index(str(annee))
        immigration=[0 for x in range(p)]
        immigrationhomme=[0 for x in range(p)]
        immigrationfemme=[0 for x in range(p)]
        for i in range(p-1):
            div=initiale[i] if initiale[i]!=0 else 1
            divhomme=hommes[i] if hommes[i]!=0 else 1
            divfemme=femmes[i] if femmes[i]!=0 else 1
            try:
                immigration[i]=float(fichierimmigration[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))/div
            except:
                immigration[i]=0
            try:
                immigrationhomme[i]=float(fichierimmigrationhomme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))/divhomme
            except:
                immigrationhomme[i]=0
            try:
                immigrationfemme[i]=float(fichierimmigrationfemme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))/divfemme
            except:
                immigrationfemme[i]=0
        for i in range(p-1,len(fichierimmigration)-2):
            div=initiale[p-1] if initiale[p-1]!=0 else 1
            divhomme=hommes[p-1] if hommes[p-1]!=0 else 1
            divfemme=femmes[p-1] if femmes[p-1]!=0 else 1
            try:
                immigration[p-1]+=float(fichierimmigration[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))/div
            except:
                immigration[p-1]+=0

            try:
                immigrationhomme[p-1]+=float(fichierimmigrationhomme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))/divhomme
            except:
                immigrationhomme[p-1]+=0
            try:
                immigrationfemme[p-1]+=float(fichierimmigrationfemme[i+2][colonne].replace(",",".").replace( "\xa0","").replace(" ",""))/divfemme
            except:
                immigrationfemme[p-1]+=0
    return initiale,mortalite,fecondite,emmigration,immigration,fichierpopulationinitiale,femmes,mortalitehomme,mortalitefemme,hommes,immigrationhomme,immigrationfemme,emmigrationhomme,emmigrationfemme,fichierfemme,fichierhomme


############################################################################################################################




#################################LES MATRICES X(0),I et L###########################
def matsurvie(mortalite,emmigration,reste=[0 for x in range(p)]):#population qui passe à la classe suivante
    """valeur par defaut de reste est 0 car pas de temps = durée d'une classe d'âge"""
    survie=[(1-mortalite[x]-emmigration[x]-reste[x]) for x in range(p-1)]
    return survie

def matimmigration(immigration):#matrice I
    matrice=np.zeros((p,p))
    for i in range(p):#complexité : O(p)
        matrice[i,i]=immigration[i]
    return matrice

def matrice(liste):#matrice X(0)
    matrice=np.array([[x] for x in liste])
    #print("matrice initiale : \n",matrice)
    return (matrice)

def Leslie(fecondite,survie,reste=[0 for x in range(p)]):#matrice L
    matrice=[[0 for x in range(p)] for y in range(p-1)]
    for i in range(p-1):#complexité : O(p)
        matrice[i][i]=survie[i]
    matrice=np.concatenate((np.array([fecondite]),np.array(matrice)),axis=0).tolist()
    for i in range(p):#complexité : O(p)
        matrice[i][i]+=reste[i]
    matrice=np.array(matrice)
    #print("matrice de Leslie : \n",matrice)
    return (matrice)

def fonction(matrice,Leslie,immigration,logistique,K):
    if logistique:
        for j in range(p):
                Leslie[0,j]*=(1-sum([matrice[0][j] for j in range(len(matrice[0]))])/K) if (K-sum([matrice[0][j] for j in range(len(matrice[0]))]))>0 else 0
    return Leslie+immigration
################################################écarts relatifs##################################################
def ecart(resultat,yliste2,pastemps,annee,populationinitiale):
    arret=pastemps+1#pour la population totale
    a=True
    colonne=populationinitiale[0].index(str(annee))
    ecarttot=[0 for i in range(pastemps+1)]
    ecartrelatif=[[0 for i in range(pastemps+1)] for j in range(p)]
    #initiale=[[0 for j in range(p)] for i in range(p)]
    for i in range(pastemps+1):#complexité : O(p)
        try:
            tot=populationinitiale[1][colonne+i].replace(",",".").replace( "\xa0","").replace(" ","")
            ecarttot[i]=abs(float(tot)-yliste2[i])/float(tot)
        except:
            ecarttot[i]="pas d'info"
            if a:
                arret=i
                a=False
        for j in range(p-1):#complexité : O(p)
            try:
                init=populationinitiale[j+2][colonne+i].replace(",",".").replace( "\xa0","").replace(" ","")
                ecartrelatif[j][i]=abs(float(init)-resultat[j][i])/float(init)
            except:
                ecartrelatif[j][i]="pas d'info"
        init=0
        for j in range(p-1,len(populationinitiale)-2):
            try:
                init+=float(populationinitiale[j+2][colonne+i].replace(",",".").replace( "\xa0","").replace(" ",""))
            except:
                pass
        if float(init)!=0:
            ecartrelatif[p-1][i]=abs(float(init)-resultat[p-1][i])/float(init)
        else:
            ecartrelatif[p-1][i]="pas d'info"
    return ecartrelatif,ecarttot,arret

####################################################################################################################
def tracer(n,yliste,yliste2,ecartliste,ecartlistetot,arret,ti,hs=None):#complexité : O(np)
    if hs==None:
        xliste=[i for i in range(n+1)]
    else:
        xliste=np.linspace(0,n,hs)
    plt.subplot(221)
    for i in range(len(yliste)): # complexité : O(p)
        plt.plot(xliste,yliste[i])
    plt.xlabel("pas de temps n")
    plt.ylabel("nb d'individu")
    plt.legend()
    plt.grid()
    plt.title("Evolution d'une population en "+str(p)+" classes d'âges selon le modèle de Leslie.")
    plt.subplot(222)
    plt.plot(xliste,yliste2,label="population totale")
    plt.xlabel("pas de temps n")
    plt.ylabel("nb d'individu")
    plt.legend()
    plt.grid()
    ##ecarts relatifs
    #plt.figure(2)
    #pour chaque classe
    plt.subplot(223)
    xliste=[i for i in range(len(ecartliste[0]))]
    for i in range(len(yliste)): # complexité : O(pn)
        try:
            plt.plot(xliste[:arret],ecartliste[i][:arret])
        except:
            pass
    plt.xlabel("annee")
    plt.ylabel("erreur relative")
    plt.legend()
    plt.grid()
    ##pour la population totale
    plt.subplot(224)
    xliste=[i for i in range(len(ecartlistetot))]
    plt.plot(xliste[:arret],ecartlistetot[:arret],label="erreur relative")
    plt.xlabel("annee")
    plt.ylabel("erreur relative")
    plt.legend()
    plt.grid()
    tf=time()
    print("temps d'execution : ",tf-ti,"s")
    plt.show()
######################################################################################################
def matriciel(matrice,Leslie,immigration,n,annee,fichierpopulationinitiale,logistique=False,K=float("inf")):#complexité : O(np^3)
    #global fichierpopulationinitiale
    yliste=[[0 for i in range(n+1)] for x in range(matrice.shape[0])]
    yliste2=[0 for i in range(n+1)]
    for x in range(len(yliste)):#complexité : O(p)
        yliste[x][0]=matrice[x,0] #initialisation |
        yliste2[0]+=matrice[x,0]
    if logistique and K!=float("inf"):
        for i in range (n):#compléxité : O(p^3n)
            matrice=np.dot(fonction(matrice,Leslie,immigration,logistique,K),matrice)#complexité : O(p^3) au pire et O(p^2) au mieux
            for x in range(len(yliste)):# complexité : O(p)
                yliste[x][i+1]=matrice[x,0]
                yliste2[i+1]+=matrice[x,0]
    else:
        for i in range (n):#compléxité : O(p^3n)
            matrice=np.dot(Leslie+immigration,matrice)#complexité : O(p^3) au pire et O(p^2) au mieux
            for x in range(len(yliste)):# complexité : O(p)
                yliste[x][i+1]=matrice[x,0]
                yliste2[i+1]+=matrice[x,0]
    ecartliste,ecartlistetot,arret=ecart(yliste,yliste2,n,annee,fichierpopulationinitiale)
    return matrice,yliste,yliste2,ecartliste,ecartlistetot,arret
#############################################################################################"

############################################enregistrement des résultats en csv#####################
def enregistrement(tableau):#complexité : O(n)
    resultat=[";".join(tableau[x])+"\n" for x in range(len(tableau))]
    fichier=open("resultatsimulation.csv","w")
    fichier.writelines(resultat)
    fichier.close()


def tableau(yliste,yliste2,ecartliste,ecarttot,n,annee):#complexité : O(np)
    tableau=[[0 for x in range(2*n+3)] for i in range(len(yliste)+2)]
    tableau[0][0]="AGE/TIME"
    tableau[1][0]="TOTAL"
    for j in range(1,len(tableau[0])):#complexité : O(n)
        if (j-1)%2==0:
            tableau[0][j]=str(annee+(j-1)//2)
            tableau[1][j]=str(yliste2[(j-1)//2])
        else:
            tableau[0][j]="ecart relatif"
            tableau[1][j]=str(ecarttot[j//2-1])
    for i in range(2,len(tableau)):#complexité : O(pn)
        tableau[i][0]=str(i-2)
        for j in range(1,len(tableau[i])): #complexité : O(n)
            if (j-1)%2==0:
                tableau[i][j]=str(yliste[i-2][(j-1)//2])
            else:
                tableau[i][j]=str(ecartliste[i-2][j//2-1])
    return tableau















###########################fonction principale######################################################################

#def callback():#complexité : O(np^3)
#    global initiale,mortalite,fecondite,emmigration,immigration,fichierpopulationinitiale,ti,p,fig
#    fig=plt.figure()
#    try:
#        ti=time()
#        annee=int(entree1.get())
#        n=int(nentry.get())
#        p=int(entree2.get())
#        initiale,mortalite,fecondite,emmigration,immigration,fichierpopulationinitiale,femmes=ouverturefichier(pop,mort,fec,em,im,annee)
#        if immigration_check_var.get():
#            print("!!! on ne prends pas en compte l'immigration")
#            immigration=[0 for i in range(len(immigration))]
#        if emmigration_check_var.get():
#            print("!!! on ne prends pas en compte l'emmigration")
#            emmigration=[0 for i in range(len(emmigration))]
#        survie=matsurvie(mortalite,emmigration)
#        resultat,yliste,yliste2,ecartliste,ecartlistetot,arret=matriciel(matrice(initiale),Leslie(fecondite,survie)+matimmigration(immigration),n,annee)
#        #print("[+] population au pas de temps "+str(n)+" : \n",resultat)
#        tot=0
#        for i in range(len(resultat)):#complexité : O(n)
#            tot+=resultat[i][0]
#        #print("[+] population totale au pas de temps "+str(n)+" : ",tot)
#
#        enregistrement(tableau(yliste,yliste2,ecartliste,ecartlistetot,n,annee))
#        tracer(n,yliste,yliste2,ecartliste,ecartlistetot,arret)
#    except IndexError as erreur:
#        messagebox.showerror("erreur","Veuillez modifiez le paramètre (ou le script :))\n"+str(erreur)+"\n"+str(erreur.args))
#
#
#if __name__=="__main__":
#    fenetre=tk.Tk()
#    fenetre.title("Leslie | Dubard, Alcaraz, Monier")
#    partie1=tk.Frame(fenetre,borderwidth=2,relief=tk.GROOVE)
#    partie1.pack(side=tk.LEFT)
#    partie2=tk.Frame(fenetre,borderwidth=2,relief=tk.GROOVE)
#    partie2.pack(side=tk.LEFT)
#    #
#    frame11=tk.Frame(partie1,borderwidth=2)
#    frame11.pack(padx=10,pady=10)
#    frame21=tk.Frame(partie1,borderwidth=2)
#    frame21.pack(padx=10,pady=10)
#    frame31=tk.Frame(partie1,borderwidth=2)
#    frame31.pack(padx=10,pady=10)
#    frame41=tk.Frame(partie1,borderwidth=2)
#    frame41.pack(padx=10,pady=10)
#    frame51=tk.Frame(partie1,borderwidth=2)
#    frame51.pack(padx=10,pady=10)
#    #
#    frame1=tk.Frame(partie2,borderwidth=2,relief=tk.GROOVE)
#    frame1.pack(padx=10,pady=10)
#    frame2=tk.Frame(partie2,borderwidth=2,relief=tk.GROOVE)
#    frame2.pack(padx=10,pady=10)
#    frame3=tk.Frame(partie2,borderwidth=2,relief=tk.GROOVE)
#    frame3.pack(padx=10,pady=10)
#
#
###################################################################################################
#    tk.Label(frame11,text="fichier population initiale").pack()
#    tk.Label(frame21,text="fichier mortalité").pack()
#    tk.Label(frame31,text="fichier fécondité").pack()
#    tk.Label(frame41,text="fichier emigration").pack()
#    tk.Label(frame51,text="fichier immigration").pack()
#    fichier1=tk.Entry(frame11,width=50);fichier1.pack(side=tk.LEFT)
#    fichier1.insert(0,pop)
#    fichier2=tk.Entry(frame21,width=50);fichier2.pack(side=tk.LEFT)
#    fichier2.insert(0,mort)
#    fichier3=tk.Entry(frame31,width=50);fichier3.pack(side=tk.LEFT)
#    fichier3.insert(0,fec)
#    fichier4=tk.Entry(frame41,width=50);fichier4.pack(side=tk.LEFT)
#    fichier4.insert(0,em)
#    fichier5=tk.Entry(frame51,width=50);fichier5.pack(side=tk.LEFT)
#    fichier5.insert(0,im)
#    def parcourir():
#        filename =askopenfilename(parent = fenetre,filetypes=(("csv files","*.csv"),("All files","*.*")),title = 'Veuillez entrer un nom de fichier ')
#        return filename
#    def bouton1fct():
#        global pop
#        pop=parcourir()
#        fichier1.delete(0,tk.END)
#        fichier1.insert(0,pop)
#    def bouton2fct():
#        global mort
#        mort=parcourir()
#        fichier2.delete(0,tk.END)
#        fichier2.insert(0,mort)
#    def bouton3fct():
#        global fec
#        fec=parcourir()
#        fichier3.delete(0,tk.END)
#        fichier3.insert(0,fec)
#    def bouton4fct():
#        global em
#        em=parcourir()
#        fichier4.delete(0,tk.END)
#        fichier4.insert(0,em)
#    def bouton5fct():
#        global im
#        im=parcourir()
#        fichier5.delete(0,tk.END)
#        fichier5.insert(0,im)
#    bouton1=tk.Button(frame11,text="parcourir",command=bouton1fct);bouton1.pack(side=tk.BOTTOM)
#    bouton2=tk.Button(frame21,text="parcourir",command=bouton2fct);bouton2.pack(side=tk.BOTTOM)
#    bouton3=tk.Button(frame31,text="parcourir",command=bouton3fct);bouton3.pack(side=tk.BOTTOM)
#    bouton4=tk.Button(frame41,text="parcourir",command=bouton4fct);bouton4.pack(side=tk.BOTTOM)
#    bouton5=tk.Button(frame51,text="parcourir",command=bouton5fct);bouton5.pack(side=tk.BOTTOM)
########################################################################################################
#    tk.Label(frame1,text="nb de classes d'âges : ").pack(side=tk.LEFT)
#    entree2=tk.Entry(frame1);entree2.pack(side=tk.LEFT)
#    entree2.insert(0,str(p))
#    tk.Label(frame2,text="entrez l'année initiale :").pack(side=tk.LEFT)
#    entree1=tk.Entry(frame2);entree1.pack(side=tk.LEFT)
#    entree1.insert(0,str(annee))
#    tk.Label(frame3,text="pas de temps max :").pack(side=tk.LEFT)
#    nentry=tk.Entry(frame3);nentry.pack(side=tk.LEFT)
#    immigration_check_var=tk.BooleanVar()
#    emmigration_check_var=tk.BooleanVar()
#    immigration_check_button=tk.Checkbutton(frame3,var=immigration_check_var,text="sans immigration");immigration_check_button.pack(side=tk.BOTTOM)
#    emigration_check_button=tk.Checkbutton(frame3,var=emmigration_check_var,text="sans emmigration");emigration_check_button.pack(side=tk.BOTTOM)
#    Bouton=tk.Button(frame3,text="Tracer",command=callback);Bouton.pack(side=tk.BOTTOM)
#    fenetre.mainloop()
