
# -*- coding: utf-8 -*-


import numpy as np
import random as rd


from math import sqrt

def prodAx(A,x):
    n=len(A)
    y=list()
    for i in range(n):
        s=0
        for k in range(n):
            s+=A[i][k]*x[k]
        y.append(s)
    return y

def puissance(A,tol,nmax):
    n=len(A)
    y=[0]*n
    y[1]=1
    v=sum(map(lambda x1,x2: x1*x2,y,prodAx(A,y)))
    res=tol+1
    niter=1

    while (res>=tol) and (niter<=nmax):
        Ay=prodAx(A,y)
        vy=[val*v for val in y]
        Ay_vy=[val1-val2 for val1,val2 in zip(Ay,vy)]
        res=sqrt(sum(map(lambda x:x**2,Ay_vy)))
        y=prodAx(A,y)
        norm_y=sqrt(sum(map(lambda x:x**2,y)))
        y=[val/norm_y for val in y]
        v=sum(map(lambda x1,x2:x1*x2,y,prodAx(A,y)))
        niter+=1
        if niter>nmax:
            return None
    return v,y

def deflation(A,tol,niter):
    n=len(A)
    v,y=puissance(A,tol,niter)
    list_vp=[v]
    list_yp=[y]
    for compteur in range(n-1):
        A=[[A[i][j]-v*y[i]*y[j] for j in range(n)] for i in range(n)]
        v,y=puissance(A,tol,niter)
        list_vp.append(v)
        list_yp.append(y)
    return list_vp,list_yp



